#!/usr/bin/perl

#Guessing the map is stored as a 3d array of bytes for block type 
# 0 would equal open air
# Top of file is bottom of map
# Map Size is 256x256x64
# 01 = Stone
# 02 = Grass
# 03 = Dirt
# 04 = Stone Rocks
# 05 = Wood planks
# 06 = Guessing Plants but bogs the server down
# 07 = Side Wall Stone
# 08 = Water
# 09 = Water
# 0a = Lava
# 0b = Lava
# 0c = Sand
# 0d = Gravel
# 0e = Gold
# 0f = Copper
# 10 = Coal/Oil
# 11 = Tree Trunk
# 12 = Tree Leaves

#####################################################################################################

$halfway = 108;
$maxheight = 60; 
$variation = 20;
$levelsize = 256;
$dirtdepth = 4;
$trees = 1000;
$variationchange = 16;

print "Started\n";

my $c1 = int(rand($maxheight) + $halfway); #Z for X,Y
my $c2 = int(rand($maxheight) + $halfway); #Z for X,MY
my $c3 = int(rand($maxheight) + $halfway); #Z for MX,Y
my $c4 = int(rand($maxheight) + $halfway); #Z for MX,MY

$j = 0;
for($i=($c1-1);$i>=0;$i--)
{
	$j++;
	if ($j < $dirtdepth)
	{
		$map[0][0][$i] = "03";
	}
	else
	{
		$map[0][0][$i] = "01";
	}
}

$j = 0;
for($i=($c2-1);$i>=0;$i--)
{
	$j++;
	if ($j < $dirtdepth)
	{
		$map[0][$levelsize][$i] = "03";
	}
	else
	{
		$map[0][$levelsize][$i] = "01";
	}
}

$j = 0;
for($i=($c3-1);$i>=0;$i--)
{
	$j++;
	if ($j < $dirtdepth)
	{
		$map[$levelsize][0][$i] = "03";
	}
	else
	{
		$map[$levelsize][0][$i] = "01";
	}
}

$j = 0;
for($i=($c4-1);$i>=0;$i--)
{
	$j++;
	if ($j < $dirtdepth)
	{
		$map[$levelsize][$levelsize][$i] = "03";
	}
	else
	{
		$map[$levelsize][$levelsize][$i] = "01";
	}
}




#print "$c1 $c2 $c3 $c4\n";

$zmap[0][0] = $c1;
$zmap[0][$levelsize] = $c2;
$zmap[$levelsize][0] = $c3;
$zmap[$levelsize][$levelsize] = $c4;

#print "$map[1][1] $map[1][256] $map[256][1] $map[256][256]\n";

$map[0][0][$c1] = "02";
$map[0][$levelsize][$c2] = "02";
$map[$levelsize][0][$c3] = "02";
$map[$levelsize][$levelsize][$c4] = "02";

&MapMaker(0,0,$levelsize,$levelsize);

#add water to the map
print "Adding Water\n";
for($a=0;$a<=$levelsize;$a++)
{
	for($b=0;$b<=$levelsize;$b++)
	{
		for($c=128;$c>0;$c--)
		{
			if($map[$a][$b][$c] eq "")
			{
				
				$map[$a][$b][$c] = "09";
				$water = 1;
			}
			else
			{
				if ($water) { $map[$a][$b][$c] = "0c"; }
				$water = 0;
				last;
			}
		}
	}
}

print "Adding Trees\n";
#Add trees to the map
$treenum = int(rand($trees)+1);
for ($i=0;$i<$treenum;$i++)
{
	$randx = int(rand(255) + 1);
	$randy = int(rand(255) + 1);
	&BuildTree($randx,$randy,240);
}

open (HEADER, "header.dat");
binmode HEADER;
open (FOOTER, "footer.dat");
binmode FOOTER;
open (LEVEL, ">server_level");
binmode LEVEL;

read (HEADER, $input, 319);
print LEVEL $input;

print "Saving Map\n";
#exit;
for ($lz=0;$lz<$levelsize;$lz++)
{
	for($ly=0;$ly<$levelsize;$ly++)
	{
		for ($lx=0;$lx<$levelsize;$lx++)
		{
			$out = $map[$lx][$ly][$lz];
			if ($out eq "")
			{
				$out = "00";
			}
			$op = pack("H*",$out);
			print LEVEL $op;
		}
	}
}

read (FOOTER, $input, 74);
print LEVEL $input;

print "\nDone\n";
close (HEADER);
close (FOOTER);
close (LEVEL);

sub BuildTree
{
	my $tx = @_[0];
	my $ty = @_[1];
	my $tz = @_[2];
	my $i = 0;
	#print "$map[$tx][$ty]\n";
	#find ground
	for ($i=$tz;$i>0;$i--)
	{
		if ($map[$tx][$ty][$i] eq "02")
		{
			$tz = $i + 1;
			last;
		}
	}
	if ($tz == 240)
	{
		return;
	}
	
	my $oldz = $tz;
	
	for ($i=0;$i<5;$i++)
	{
		$map[$tx][$ty][$tz+$i] = "11";
	}
	$map[$tx][$ty][$tz+$i] = "12";
	$i--;
	$tx--;
	$map[$tx][$ty][$tz+$i] = "12";
	$tx = $tx +2;
	$map[$tx][$ty][$tz+$i] = "12";
	$tx--;

	$ty--;
	$map[$tx][$ty][$tz+$i] = "12";
	$ty = $ty +2;
	$map[$tx][$ty][$tz+$i] = "12";
	$ty--;
	$i--;
	
	
	my $ta = $tx - 2;
	my $tb = $ty - 2;
	
	for (my $a=$ta;$a<=$tx+2;$a++)
	{
		for (my $b=$tb;$b<=$ty+2;$b++)
		{
			if (!($a == $tx && $b == $ty))
			{
				$map[$a][$b][$tz+$i] = "12";
				$map[$a][$b][$tz+$i-1] = "12";
			}
		}
	}
}

sub MapMaker
{
	my $x = @_[0];
	my $y = @_[1];
	my $mx = @_[2];
	my $my = @_[3];

	#print "#";
	my $hx = int(($mx - $x) / 2);
	my $hy = int(($my - $y) / 2);
	
	$hx = $hx + $x;
	$hy = $hy + $y;
	
	$lenx = $mx - $x;
	$leny = $my - $y;
	
	#print "Values \t $x $y $mx $my $hx $hy $lenx $leny\n";
	#print "Map \t " . $map[$x][$y] ." ". $map[$x][$my] ." ". $map[$mx][$y] ." ". $map[$mx][$my] ."\n";	

	$zmap[$hx][$y]  = int(($zmap[$x][$y]  + $zmap[$mx][$y] ) / 2) unless ($zmap[$hx][$y]  ne "");
	$zmap[$x][$hy]  = int(($zmap[$x][$y]  + $zmap[$x][$my] ) / 2) unless ($zmap[$x][$hy]  ne "");
	$zmap[$hx][$my]  = int(($zmap[$x][$my]  + $zmap[$mx][$my] ) / 2) unless ($zmap[$hx][$my]  ne "");
	$zmap[$mx][$hy]  = int(($zmap[$mx][$y]  + $zmap[$mx][$my] ) / 2) unless ($zmap[$mx][$hy]  ne "");
	$zmap[$hx][$hy]  = int(($zmap[$x][$y]  + $zmap[$mx][$y]  + $zmap[$x][$my]  +$zmap[$mx][$my] ) / 4) unless ($zmap[$hx][$hy]  ne "");
	
	#print "Array \t $map[$hx][$y] $map[$x][$hy] $map[$hx][$my] $map[$mx][$hy] $map[$hx][$hy]\n";

	my $z1 = 0;
	my $z2 = 0;
	my $z3 = 0;
	my $z4 = 0;
	my $z5 = 0;


	if ($hx % $variationchange == 0) # Change this to something else.... not sure what
	{
		$z1 = int(rand($variation) + ($zmap[$hx][$y]  - ($variation / 2))); #Z for X,Y
		$z2 = int(rand($variation) + ($zmap[$x][$hy]  - ($variation / 2))); #Z for X,MY
		$z3 = int(rand($variation) + ($zmap[$hx][$my] - ($variation / 2))); #Z for MX,Y
		$z4 = int(rand($variation) + ($zmap[$mx][$hy]  - ($variation / 2))); #Z for MX,MY
		$z5 = int(rand($variation) + ($zmap[$hx][$hy]  - ($variation / 2))); #Z for MX,MY
		#print " #\n";
	}
	else
	{
		$z1 = $zmap[$hx][$y] ; #Z for X,Y
		$z2 = $zmap[$x][$hy] ; #Z for X,MY
		$z3 = $zmap[$hx][$my] ; #Z for MX,Y
		$z4 = $zmap[$mx][$hy] ; #Z for MX,MY
		$z5 = $zmap[$hx][$hy] ; #Z for MX,MY
		#print " .\n";
	}
	
	$zmap[$hx][$y]  = $z1;
	$zmap[$x][$hy]  = $z2; 
	$zmap[$hx][$my]  = $z3; 
	$zmap[$mx][$hy]  = $z4; 
	$zmap[$hx][$hy]  = $z5; 

	#print "Rand \t $map[$hx][$y] $map[$x][$hy] $map[$hx][$my] $map[$mx][$hy] $map[$hx][$hy]\n";
	#print "$z1 $z2 $z3 $z4 $z5\n";
	
	$map[$hx][$y][$z1] = "02";
	$map[$x][$hy][$z2] = "02";
	$map[$hx][$my][$z3] = "02";
	$map[$mx][$hy][$z4] = "02";
	$map[$hx][$hy][$z5] = "02";
	
	$j = 0;
	for($i=($z1-1);$i>=0;$i--)
	{
		$j++;
		if ($j < $dirtdepth)
		{
			$map[$hx][$y][$i] = "03";
		}
		else
		{
			$map[$hx][$y][$i] = "01";
		}
	}
	
	$j = 0;
	for($i=($z2-1);$i>=0;$i--)
	{
		$j++;
		if ($j < $dirtdepth)
		{
			$map[$x][$hy][$i] = "03";
		}
		else
		{
			$map[$x][$hy][$i] = "01";
		}
	}
	$j = 0;
	for($i=($z3-1);$i>=0;$i--)
	{
		$j++;
		if ($j < $dirtdepth)
		{
			$map[$hx][$my][$i] = "03";
		}
		else
		{
			$map[$hx][$my][$i] = "01";
		}
	}
	$j = 0;
	for($i=($z4-1);$i>=0;$i--)
	{
		$j++;
		if ($j < $dirtdepth)
		{
			$map[$mx][$hy][$i] = "03";
		}
		else
		{
			$map[$mx][$hy][$i] = "01";
		}
	}
	$j = 0;
	for($i=($z5-1);$i>=0;$i--)
	{
		$j++;
		if ($j < $dirtdepth)
		{
			$map[$hx][$hy][$i] = "03";
		}
		else
		{
			$map[$hx][$hy][$i] = "01";
		}
	}
	
	if ($hx - $x > 1)
	{
		&MapMaker($x,$y,$hx,$hy);
	}
	if ($hy - $y > 1)
	{
		&MapMaker($hx,$y,$mx,$hy);
	}
	if ($hx - $x > 1)
	{
		&MapMaker($x,$hy,$hx,$my);
	}
	if ($hy - $y > 1)
	{
		&MapMaker($hx,$hy,$mx,$my);
	}
}

